
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ai_generationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ai_generations = await db.ai_generations.create(
            {
                id: data.id || undefined,
        
        generation_type: data.generation_type
        ||
        null
            ,
            
        generated_at: data.generated_at
        ||
        null
            ,
            
        prompt_context_json: data.prompt_context_json
        ||
        null
            ,
            
        result_json: data.result_json
        ||
        null
            ,
            
        status_message: data.status_message
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ai_generations.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return ai_generations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ai_generationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                generation_type: item.generation_type
            ||
            null
            ,
            
                generated_at: item.generated_at
            ||
            null
            ,
            
                prompt_context_json: item.prompt_context_json
            ||
            null
            ,
            
                result_json: item.result_json
            ||
            null
            ,
            
                status_message: item.status_message
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ai_generations = await db.ai_generations.bulkCreate(ai_generationsData, { transaction });

        // For each item created, replace relation files
        

        return ai_generations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const ai_generations = await db.ai_generations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.generation_type !== undefined) updatePayload.generation_type = data.generation_type;
        
        
        if (data.generated_at !== undefined) updatePayload.generated_at = data.generated_at;
        
        
        if (data.prompt_context_json !== undefined) updatePayload.prompt_context_json = data.prompt_context_json;
        
        
        if (data.result_json !== undefined) updatePayload.result_json = data.result_json;
        
        
        if (data.status_message !== undefined) updatePayload.status_message = data.status_message;
        
        
        updatePayload.updatedById = currentUser.id;

        await ai_generations.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await ai_generations.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return ai_generations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ai_generations = await db.ai_generations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ai_generations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ai_generations) {
                await record.destroy({transaction});
            }
        });


        return ai_generations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ai_generations = await db.ai_generations.findByPk(id, options);

        await ai_generations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ai_generations.destroy({
            transaction
        });

        return ai_generations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ai_generations = await db.ai_generations.findOne(
            { where },
            { transaction },
        );

        if (!ai_generations) {
            return ai_generations;
        }

        const output = ai_generations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await ai_generations.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.prompt_context_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ai_generations',
                        'prompt_context_json',
                        filter.prompt_context_json,
                    ),
                };
            }
            
            if (filter.result_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ai_generations',
                        'result_json',
                        filter.result_json,
                    ),
                };
            }
            
            if (filter.status_message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ai_generations',
                        'status_message',
                        filter.status_message,
                    ),
                };
            }
            

            
            

            
            if (filter.generated_atRange) {
                const [start, end] = filter.generated_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    generated_at: {
                    ...where.generated_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    generated_at: {
                    ...where.generated_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.generation_type) {
                where = {
                    ...where,
                generation_type: filter.generation_type,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ai_generations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ai_generations',
                        'status_message',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ai_generations.findAll({
            attributes: [ 'id', 'status_message' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status_message', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status_message,
        }));
    }

    
};

